; Block att to image - www.cadforum.cz

(defun ProcessAtt2Img (blkname tagname / adoc ss itm j f sp)
  (setq adoc (vla-get-ActiveDocument (vlax-get-acad-object)))
  (setq sp (if (= 1 (getvar "TILEMODE"))
				(vla-get-ModelSpace adoc)
				(vla-get-PaperSpace adoc)
			))
  (setq sp (vla-get-block (vla-get-activelayout adoc)))
  (cond
    ((and
       (ssget "_X" (list '(0 . "INSERT") (cons 2 (strcat blkname ",`*U*")))) ; blk or dynblk
       (vlax-for
          itm (setq ss (vla-get-ActiveSelectionSet adoc))
         (if (and
               (eq (strcase (vla-get-EffectiveName itm)) (strcase blkname))
               (setq itm (assoc
                 (strcase tagname)
                 (mapcar
                   (function
                     (lambda (j)
                       (list (vla-get-tagstring j)(vla-get-textstring j) j)
                     )
                   )
                   (vlax-invoke itm 'GetAttributes)
                   )
                 )
                )
               )
				(if (setq f (findfile (strcat imgfolder "/" (cadr itm) imgext))) ; image exists?
				  (if (vlax-invoke sp 'addraster f (vlax-get (last itm) 'InsertionPoint) imgscale (vlax-get (last itm) 'Rotation))
				    (vla-put-layer (last itm) attlayer) ; re-layer
				  )
				 ; else
				  (princ (strcat " Image " imgfolder "/" (cadr itm) imgext " not found! "))
				)
           )
         )
       (vla-delete ss)
       )
     )
    )
 )
 
 (defun C:BlkAtt2Img ( / blkname tagname imgfolder imgext imgscale)
  (vl-load-com)
  (setq blkname "LabelBlk") ; block name
  (setq tagname "Obrazek") ; attribute tag
  (setq imgfolder ".") ; folder with images
  (setq imgext ".png") ; image extension/type
  (setq imgscale 10.0) ; image scale
  (setq attlayer "Hidden") ; layer for old attributes (must exist)
  (ProcessAtt2Img blkname tagname)
  (princ)
 )
 